package dev.peerat.framework;

import java.lang.reflect.Method;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class RouteState {
	
	private Object instance;
	private Method method;
	private Route route;
	private Pattern pattern;
	private RouteBinder binder;
	
	public RouteState(Object instance, Method method, Route route){
		this.instance = instance;
		this.method = method;
		this.route = route;
		this.pattern = Pattern.compile(route.path());
		this.binder = new RouteBinder();
	}
	
	public void bindIndexes(){
		this.binder.bindIndexes(this.method);
	}
	
	public Matcher match(String path){
		Matcher matcher = pattern.matcher(path);
		return matcher.matches() ? matcher : null;
	}
	
	public Route getRoute(){
		return this.route;
	}
	
	public boolean isWebSocket(){
		return this.route.websocket();
	}
	
	public boolean needLogin(){
		return this.route.needLogin();
	}
	
	public Method getMethod(){
		return this.method;
	}
	
	public Object getInstance(){
		return this.instance;
	}
	
	public Pattern getPattern(){
		return this.pattern;
	}
	
	public RouteBinder getBinder(){
		return this.binder;
	}
	
}
